Home Information Classes Download Usage Mail List Requirements Links Tutorial

# FormSwep Class Reference

STK sweepable formant filter class. More...

`#include <FormSwep.h>`

Inheritance diagram for FormSwep:

List of all members.

## Public Member Functions

| FormSwep ()
| Default constructor creates a second-order pass-through filter.
| ~FormSwep ()
| Class destructor.
void | setResonance (MY_FLOAT aFrequency, MY_FLOAT aRadius)
| Sets the filter coefficients for a resonance at frequency (in Hz).
void | setStates (MY_FLOAT aFrequency, MY_FLOAT aRadius, MY_FLOAT aGain=1.0)
| Set both the current and target resonance parameters.
void | setTargets (MY_FLOAT aFrequency, MY_FLOAT aRadius, MY_FLOAT aGain=1.0)
| Set target resonance parameters.
void | setSweepRate (MY_FLOAT aRate)
| Set the sweep rate (between 0.0 - 1.0).
void | setSweepTime (MY_FLOAT aTime)
| Set the sweep rate in terms of a time value in seconds.
MY_FLOAT | tick (MY_FLOAT sample)
| Input one sample to the filter and return one output.
MY_FLOAT * | tick (MY_FLOAT *vector, unsigned int vectorSize)
| Input vectorSize samples to the filter and return an equal number of outputs in vector.

## Detailed Description

STK sweepable formant filter class.

This public BiQuad filter subclass implements a formant (resonance) which can be "swept" over time from one frequency setting to another. It provides methods for controlling the sweep rate and target frequency.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 20 of file FormSwep.h.

## Member Function Documentation

void FormSwep::setResonance | ( | MY_FLOAT | aFrequency,
|  | MY_FLOAT | aRadius
| ) |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. The filter zeros are placed at z = 1, z = -1, and the coefficients are then normalized to produce a constant unity gain (independent of the filter gain parameter). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width.

void FormSwep::setSweepRate | ( | MY_FLOAT | aRate | ) |

| Set the sweep rate (between 0.0 - 1.0). The formant parameters are varied in increments of the sweep rate between their current and target values. A sweep rate of 1.0 will produce an immediate change in resonance parameters from their current values to the target values. A sweep rate of 0.0 will produce no change in resonance parameters.

void FormSwep::setSweepTime | ( | MY_FLOAT | aTime | ) |

| Set the sweep rate in terms of a time value in seconds. This method adjusts the sweep rate based on a given time for the formant parameters to reach their target values.

The documentation for this class was generated from the following file:

- FormSwep.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.